%FULLHIST Full histogram. Intensity - Grayscale Images
%   FULLHIST for each intensity caclulated the number of pixels 
%   with the same intensity. It may be easier to think of FULLHIST
%   as using the HISt function with infinite number of bins (or a 
%   bin for each color).
%   
%   H = FULLHIST(A) counts the number of pixels for each color. The 
%   color bins are ordered by the color.
%   
%   [H,C] = FULLHIST(A) returns the colors in addition.

A=radread0('zbelg-h.hdr');
A=imread('Ione_Fine_gamma.tif');
A=imread('Ione_Fine_B&W2.tif');
A=imread('b-3.jpg');
A=imOut3;

A1=A(:,:,1);
A2=A(:,:,2);
A3=A(:,:,3);

B1 = sort(A1(:));
F1 = B1(1:end-1)~=B1(2:end);
H1 = find([F1;1]);
B1(~F1) = [];

B2 = sort(A2(:));
F2 = B2(1:end-1)~=B2(2:end);
H2 = find([F2;1]);
B2(~F2) = [];

B3 = sort(A3(:));
F3 = B3(1:end-1)~=B3(2:end);
H3 = find([F3;1]);
B3(~F3) = [];

%bar(H1);
%bar(H2);
%bar(H3);

%bar(B1);
%bar(B2);
%bar(B3);

figure;plot(H1);
figure;plot(H2);
figure;plot(H3);

figure;plot(B1);
figure;plot(B2);
figure;plot(B3);
