    function X=Poisson_FFT(b)
    [n,m]=size(b);
    % Form eigenvalues of matrix T(nxn)
    L=2*(1-cos((1:n)*pi/(n+1))); 
    % Form reciprocal sums of eigenvalues. Include scale factor 2/(n+1).
    LL=(2/(n+1))*ones(n,n)./(L'*ones(1,n)+ones(n,1)*L);
    % Solve, using the Fast Sine Transform 
    X = fast_sine_transform(b');
    X = fast_sine_transform(X');
    X = LL .* X;
    X = fast_sine_transform(X');
    X = fast_sine_transform(X');

     % Fast Sine Transform on input matrix V of dimension n-by-m
     function Y=fast_sine_transform(V)
     [n,m]=size(V); 
     V1=[zeros(1,m);V;zeros(n+1,m)]; 
     V2=imag(fft(V1)); 
     % In Matlab vectors and matrices are indexed starting at 1, not 0
     Y=V2(2:n+1,:);    

% Finite differences equation:
%          d^2 u(i*h,j*h)   U(i-1,j) - 2*U(i,j) + U(i+1,j)
%          -------------- ~ ------------------------------
%               d x^2                   h^2
%
%          d^2 u(i*h,j*h)   U(i-1,j) - 2*U(i,j) + U(i+1,j)   
%          -------------- ~ ------------------------------ 
%               d x^2                   h^2                  
%
%                   -1    
%                 = --- * (U*T)(i,j)
%                   h^2
%
%                   T*U + U*T = B
%
