%FULLHIST Full histogram. Intensity - Grayscale Images
%   FULLHIST for each intensity caclulated the number of pixels 
%   with the same intensity. It may be easier to think of FULLHIST
%   as using the HISt function with infinite number of bins (or a 
%   bin for each color).
%   
%   H = FULLHIST(A) counts the number of pixels for each color. The 
%   color bins are ordered by the color.
%   
%   [H,C] = FULLHIST(A) returns the colors in addition.

% Zvi Devir & Liliya Tridensky
% Sep 2002

function [H,B] = fullHist(A);

B = sort(A(:));
F = B(1:end-1)~=B(2:end);
H = find([F;1]);
B(~F) = [];
