function phi = gradientAttenuator(H,alpha,beta)
% Images with dimensions that are powers of two may crash. Invetigate the "one less than power of two" pheonomemon
% If so, manually run this routine and continue using the residual phi.
% if (~any(mod(size(H),2)) & all(size(H) > 33) ) 


gradHx = 0.5*[ zeros(size(H,1),1), H(:,3:end)-H(:,1:(end-2)), zeros(size(H,1),1)];
gradHy = 0.5*[ zeros(1,size(H,2)); H(3:end,:)-H(1:(end-2),:); zeros(1,size(H,2))];
gradH  = sqrt(gradHx.^2+gradHy.^2);

%  alpha, beta, and 's'
%  This is a two-parameter family of functions. The first parameter
%  'a' determines which gradient magnitudes remain unchanged (mul-
%  tiplied by a scale factor of 1).  Gradients of larger magnitude are
%  attenuated (assuming 'b' < 1), while gradients of magnitude smaller
%  than a are slightly magnified.  In all the results shown in this paper 
%  we set 'a'  to 0.1 times the average gradient magnitude, and 'b'
%  between 0.8 and 0.9.
%  Cout =(Cin / Lin)^s*Lout	: 's' is a saturation factor


phi = (gradH/(alpha*mean2(gradH))).^(beta-1);
phi(phi>1) = 1;
% y = sum(x(:))/prod(size(x));	% imagery/imagery/mean2.m
% res = mean(mean(mtx));	% pyrtools/mean2.m

if (~any(mod(size(H),2)) & all(size(H) > 33) ) 
      redH=reduce(0.5*H);
     gAtt=gradientAttenuator( redH, alpha, beta);
     %disp(['Generating one more level on the pyramid, sized ' num2str(size(H))]);
     disp(['Min phi = ' num2str(min2(phi)) ', Max phi = ' num2str(max2(phi)) ]);
     disp([ 'phi=' num2str(size(phi))]);
     disp([ 'expand(gAtt)=' num2str(size(expand(gAtt))) ]);
     
%     phi = phi.*expand(gradientAttenuator(reduce(.5*H),alpha,beta));
     reduced=reduce(.5*H);
     gAtt_reduced=gradientAttenuator(reduced,alpha,beta);
     disp(['gAtt_reduced = ' num2str(size(gAtt_reduced))]);
     phi=phi.*expand(gAtt_reduced);
     disp(['phi = ' num2str(size(phi))]);     
end
disp('exit');
