function phi = gradientAttenuator(H,alpha,beta)

gradHx = 0.5*[ zeros(size(H,1),1), H(:,3:end)-H(:,1:(end-2)), zeros(size(H,1),1)];
gradHy = 0.5*[ zeros(1,size(H,2)); H(3:end,:)-H(1:(end-2),:); zeros(1,size(H,2))];
gradH  = sqrt(gradHx.^2+gradHy.^2);

phi = (gradH/(alpha*mean2(gradH))).^(beta-1);
phi(phi>1) = 1;

% if both dimensions are divisible by 2 and greater than 32
% emits an error; resumption will finish without further errors.
if (~any(mod(size(H),2)) & all(size(H) > 33) ) 
      redH=reduce(0.5*H);
     gAtt=gradientAttenuator( redH, alpha, beta);
     %disp(['Generating one more level on the pyramid, sized ' num2str(size(H))]);
     disp(['Min phi = ' num2str(min2(phi)) ', Max phi = ' num2str(max2(phi)) ]);
     disp([ 'phi=' num2str(size(phi))]);
     disp([ 'expand(gAtt)=' num2str(size(expand(gAtt))) ]);
     
%     phi = phi.*expand(gradientAttenuator(reduce(.5*H),alpha,beta));
     reduced=reduce(.5*H);
     gAtt_reduced=gradientAttenuator(reduced,alpha,beta);
     disp(['gAtt_reduced = ' num2str(size(gAtt_reduced))]);
     phi=phi.*expand(gAtt_reduced);
     disp(['phi = ' num2str(size(phi))]);     
end
disp('exit');

% from Upsample0.m - Nam-Deuk Kim
% Min phi = 0.63919, Max phi = 1
% phi=48  64
% size(A)26  34
% size(A)68  52
% expand(gAtt)=100  132
% exit
% size(A)26  34
% size(A)68  52
% 
% ??? Error using ==> .*
% Matrix dimensions must agree.
% gradientAttenuator.m On line 22  ==>      phi=phi.*expand(gAtt_reduced);
% gradientAttenuator.m On line 13  ==>      gAtt=gradientAttenuator( redH, alpha, beta);
% gradientAttenuator.m On line 13  ==>      gAtt=gradientAttenuator( redH, alpha, beta);

% Mathworks Upsample from Signal Processing Toolbox.
% Min phi = 0.63919, Max phi = 1
% phi=48  64
% size(A)26  34
% size(A)68  52
% expand(gAtt)=100  132
% exit
% size(A)26  34
% size(A)68  52
% 
% ??? Error using ==> .*
% Matrix dimensions must agree.
% Error in ==> gradientAttenuator.m On line 22  ==>      phi=phi.*expand(gAtt_reduced);
% gradientAttenuator.m On line 13  ==>      gAtt=gradientAttenuator( redH, alpha, beta);
% gradientAttenuator.m On line 13  ==>      gAtt=gradientAttenuator( redH, alpha, beta);
