function imOut = reduceDR(imIn,alpha,beta,s,filename);

% The Grad Atten program crashes when a dimension is one less than a power of two
% One more than a power of two will not crash. what are the real limits?

% Works but has to be manually done and restarted when 
% error occurs in 'gradientAttenuator'.
% images with dimensions that are powers of two may crash. Manually run
% the 'gradientAttenuator' routine and continue using the recovered phi.
 
% poisson_Solver2D.m 
% The phi generated immediately after the attenuation stage
% may benefit from histogram correction.
% The phi returned has a range : 45-165.

% imgDR=reduceDR(img, 0.3, 0.85, 0.6, 'zbelg');

% filename='zbelg384_512.hdr';
% filename='zbelg384_512sc6edit.hdr';
% filename='zbigfogmap.hdr';	% 751x1130
% filename='zbelg.hdr';	% 1025x769
 filename='zmemorial.hdr';	% 512x768
% filename='zgroveC.hdr';	% 480x720
% filename='zOfficeLightOnPerson.hdr';	% 1024x1280
 img0=zbigfogmap;
 img0=radread(filename);
 
 % half size the image
dim=size(img0);
img1 = img0(1:2:dim(1),1:2:dim(2),:);		
 
 imIn=img1;
 filename='zbelg.hdr';
 % alpha=0.3;
 alpha=0.1;
 beta=0.85;
 s=0.6;
% s=0.75;
% s=0.95;
 
colorlayers = size(imIn,3);
CIE1=[ 0.21  0.72  0.07];
CIE2=[0.265074126  .670114631 0.064811243];
NTSC=[ 0.30  0.59  0.11];
HDR1=[ 0.2552 1.0834 0.00];
MIN_LUM = 1.0e-3;

% luminance value
RGB=CIE1;
RGB_r=RGB(1);RGB_g=RGB(2);RGB_b=RGB(3);
if colorlayers == 3
    Lin = RGB_r*imIn(:,:,1) + RGB_g*imIn(:,:,2) + RGB_b*imIn(:,:,3);
%    image(find(image==0))=MIN_LUM; %  CIE2
else
    Lin = imIn;
end

Lin(Lin == 0) = inf;
Lin(isinf(Lin)) = min2(Lin);  	
H = log(Lin);

%===========================================
% GRADIENT ATTENUATION

%phi = gradientAttenuator(H,alpha,beta);
%imwrite(phi,'phi.tif','TIFF');
%figure;imshow(phi);

delHx = padarray([H(:,2:end)-H(:,1:(end-1))],[0 1],0,'post');
delHy = padarray([H(2:end,:)-H(1:(end-1),:)],[1 0],0,'post');
Gx = delHx.*phi;
Gy = delHy.*phi;
divGx = padarray([Gx(:,2:end)-Gx(:,1:(end-1))],[0 1],0,'pre');
divGy = padarray([Gy(2:end,:)-Gy(1:(end-1),:)],[1 0],0,'pre');
divG  = divGx + divGy;
divG2=divG;
% lower key results - jlj 2005
%
%divdelHx = padarray([delHx(:,2:end)-delHx(:,1:(end-1))],[0 1],0,'pre');
%divdelHy = padarray([delHy(2:end,:)-delHy(1:(end-1),:)],[1 0],0,'pre');
%divdelH  = divdelHx + divdelHy;


%===========================================
% SOLVER

 w=size(img1,2);h=size(img1,1);
 if (h - w) < 0
	divG(h+1:w,:,:)=0;
 else 
	divG(:,w+1:h,:)=0;
 end
I = Poisson_FFT(divG);
 if (h - w) < 0
	I2=I(1:h,:,:);
 else 
	I2=I(:,1:w,:);
 end

%I = poissonSolver2D(divG);
%I2 = poissonSolver2D(divdelH);


%===========================================
% COLOR RESTORATION

% 1/255 = 0.003922
% if pixel < 0.0038, then pixel = 0.0
%  histo counts for values above 213 only occur as 0, 1 or 2 for zbelg.

imOut = repmat(I2,[1 1 3]).*(imIn./repmat(Lin,[1 1 3])).^s;
%imOut2=imOut; % for poisson_Solver2D.m
imOut2=imOut+((-1)*min(min(min(imOut2))));
imOut2=imOut2./max(max(max(imOut2)));
imOut3= (1 - imOut2);
imOut3=imOut3./max(max(max(imOut3)));

figure;imshow(imOut3);
imwrite(imOut3,[ filename '_Out.tif'],'TIFF');

disp(['The initial image had a dynamic range of ' num2str((max2(H)-min2(H))/log(10)) ' log units.']);
disp(['The final image has a dynamic range of '   num2str((max2(I)-min2(I))/log(10)) ' log units.']);
